'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var button = require('@highlight-ui/button');
var icon = require('@highlight-ui/icon');
var i18n = require('@highlight-ui/i18n');
var utilsCommons = require('@highlight-ui/utils-commons');
var classnames = require('classnames');
var MonthSelectPlugin = require('flatpickr/dist/plugins/monthSelect');
var Flatpickr = require('flatpickr');
var de = require('flatpickr/dist/l10n/de');
var _default = require('flatpickr/dist/l10n/default');
var es = require('flatpickr/dist/l10n/es');
var fr = require('flatpickr/dist/l10n/fr');
var nl = require('flatpickr/dist/l10n/nl');
var it = require('flatpickr/dist/l10n/it');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () {
            return e[k];
          }
        });
      }
    });
  }
  n["default"] = e;
  return Object.freeze(n);
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var React__namespace = /*#__PURE__*/_interopNamespace(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var MonthSelectPlugin__default = /*#__PURE__*/_interopDefaultLegacy(MonthSelectPlugin);
var Flatpickr__default = /*#__PURE__*/_interopDefaultLegacy(Flatpickr);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function (d, b) {
  extendStatics = Object.setPrototypeOf || {
    __proto__: []
  } instanceof Array && function (d, b) {
    d.__proto__ = b;
  } || function (d, b) {
    for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
  };
  return extendStatics(d, b);
};
function __extends(d, b) {
  if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
  extendStatics(d, b);
  function __() {
    this.constructor = d;
  }
  d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}
var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var TEST_IDS = {
  MONTH_PICKER_INPUT: 'month-picker-input',
  MONTH_PICKER_TODAY_BUTTON: 'month-picker-today-button',
  MONTH_PICKER_PREVIOUS_BUTTON: 'month-picker-previous-button',
  MONTH_PICKER_NEXT_BUTTON: 'month-picker-next-button'
};
var styles = {
  "heading-xsmall": "MonthNavigation-module__4YEC2eTu__v2-5-18",
  "heading-small": "MonthNavigation-module__1E8teUI-__v2-5-18",
  "wrapper": "MonthNavigation-module__nQFMXkVr__v2-5-18",
  "input": "MonthNavigation-module__NOaimxeP__v2-5-18",
  "small": "MonthNavigation-module__C-WLLbMQ__v2-5-18",
  "heading-medium": "MonthNavigation-module__uJGwndLu__v2-5-18",
  "heading-large": "MonthNavigation-module__A9b3waAf__v2-5-18",
  "heading-xlarge": "MonthNavigation-module__CgCn9kHX__v2-5-18",
  "medium": "MonthNavigation-module__o6MRP49q__v2-5-18",
  "heading-2xl": "MonthNavigation-module__8sK7fZCJ__v2-5-18",
  "body-small": "MonthNavigation-module__HtzNy4oa__v2-5-18",
  "body-base": "MonthNavigation-module__gYquAkhC__v2-5-18",
  "body-large": "MonthNavigation-module__ol4iebsY__v2-5-18",
  "body-strong-small": "MonthNavigation-module__B5xqSa-G__v2-5-18",
  "body-strong-base": "MonthNavigation-module__jsJRF1qY__v2-5-18",
  "body-strong-large": "MonthNavigation-module__xyMpePaR__v2-5-18",
  "page-heading": "MonthNavigation-module__9BFhEXFK__v2-5-18",
  "button": "MonthNavigation-module__PRZSiZsR__v2-5-18",
  "form-label": "MonthNavigation-module__u0hDjCR3__v2-5-18",
  "caption": "MonthNavigation-module__D5aM37SS__v2-5-18",
  "text-link-default": "MonthNavigation-module__-zCl7Z2Q__v2-5-18",
  "text-link-hover": "MonthNavigation-module__DGssJXGl__v2-5-18",
  "table-data-regular": "MonthNavigation-module__DFVRHYzs__v2-5-18",
  "table-data-bold": "MonthNavigation-module__Fa8JiCtD__v2-5-18",
  "controlWrapper": "MonthNavigation-module__i7mOke17__v2-5-18",
  "controlButton": "MonthNavigation-module__WrIYawzk__v2-5-18",
  "noTodayButton": "MonthNavigation-module__GKQu9lwY__v2-5-18",
  "icon": "MonthNavigation-module__u88OooT6__v2-5-18",
  "todayButton": "MonthNavigation-module__vmwWFrZG__v2-5-18"
};
var MonthNavigationInput = /** @class */function (_super) {
  __extends(MonthNavigationInput, _super);
  function MonthNavigationInput() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.ref = null;
    _this.handleRef = function (ref) {
      if (!ref) return;
      _this.ref = ref;
    };
    return _this;
  }
  MonthNavigationInput.prototype.render = function () {
    return React__default["default"].createElement("input", __assign({}, this.props, {
      ref: this.handleRef,
      readOnly: true
    }));
  };
  return MonthNavigationInput;
}(React__default["default"].Component);
var defaultOptions = {
  locale: 'en-GB',
  initialDate: undefined,
  disableCloseOnSelectDate: false,
  disableCloseOnClickOutside: false,
  disableToggleOnClick: false,
  title: '',
  onTitleClick: function () {}
};
var defaultFlatPickrOption = {
  enableTime: false,
  inline: true,
  allowInput: false,
  prevArrow: '<i class="far fa-arrow-left"></i>',
  nextArrow: '<i class="far fa-arrow-right"></i>'
};
var POSITION = {
  BOTTOM: 'bottom',
  TOP: 'top'
};
var transformDateFormat = function (dateFormat) {
  if (typeof dateFormat === 'string') {
    return dateFormat.replace('DD', 'd').replace('MM', 'm').replace('YYYY', 'Y').replace('YY', 'y');
  }
  return dateFormat;
};
var customEnglish = __assign(__assign({}, _default.english), {
  firstDayOfWeek: 1
});
var localeDictionary = {
  'en-GB': {
    locale: customEnglish
  },
  'de-DE': {
    locale: de.German
  },
  'es-ES': {
    locale: es.Spanish
  },
  'fr-FR': {
    locale: fr.French
  },
  'nl-NL': {
    locale: nl.Dutch
  },
  'it-IT': {
    locale: it.Italian
  }
};
var getNextMonth = function (date, amount) {
  return new Date(date === null || date === void 0 ? void 0 : date.getFullYear(), (date === null || date === void 0 ? void 0 : date.getMonth()) + amount, 1);
};
var checkIfDifferentMonth = function (date1, date2) {
  if ((date1 === null || date1 === void 0 ? void 0 : date1.getFullYear()) !== (date2 === null || date2 === void 0 ? void 0 : date2.getFullYear())) return true;
  return (date1 === null || date1 === void 0 ? void 0 : date1.getMonth()) !== (date2 === null || date2 === void 0 ? void 0 : date2.getMonth());
};
var checkIfSmallerMonth = function (date1, date2) {
  if ((date1 === null || date1 === void 0 ? void 0 : date1.getFullYear()) > (date2 === null || date2 === void 0 ? void 0 : date2.getFullYear())) return false;
  if ((date1 === null || date1 === void 0 ? void 0 : date1.getFullYear()) < (date2 === null || date2 === void 0 ? void 0 : date2.getFullYear())) return true;
  return (date1 === null || date1 === void 0 ? void 0 : date1.getMonth()) < (date2 === null || date2 === void 0 ? void 0 : date2.getMonth());
};
var DatePicker = /** @class */function () {
  function DatePicker(node, options) {
    var _this = this;
    this._createCalendarWrapper = function () {
      var wrapper = document.createElement('div');
      wrapper.classList.add('personio-datepicker-wrapper');
      wrapper.appendChild(document.createElement('div'));
      if (wrapper.firstChild) {
        wrapper.firstChild.appendChild(document.createElement('div'));
      }
      return wrapper;
    };
    this._findNodeParent = function () {
      var wrapper = _this._node.parentNode;
      wrapper.classList.add('personio-datepicker-input-wrapper');
      return wrapper;
    };
    this._setCalendarWrapperPosition = function () {
      if (_this._position === POSITION.BOTTOM) {
        return;
      }
      var calendarWrapperInfo = _this._calendarWrapper.getBoundingClientRect();
      var nodeParentInfo = _this._nodeParent.getBoundingClientRect();
      if (_this._position === POSITION.TOP) {
        _this._calendarWrapper.style.top = '';
        _this._calendarWrapper.style.bottom = nodeParentInfo.height + "px";
        return;
      }
      if (calendarWrapperInfo.bottom >= window.innerHeight) {
        _this._calendarWrapper.style.top = '';
        _this._calendarWrapper.style.bottom = nodeParentInfo.height + "px";
      }
    };
    this._resetCalendarWrapperPosition = function () {
      var nodeParentInfo = _this._nodeParent.getBoundingClientRect();
      _this._calendarWrapper.style.top = nodeParentInfo.height + "px";
      _this._calendarWrapper.style.bottom = '';
    };
    this._addEventListeners = function () {
      if (!_this._option.disableToggleOnClick) {
        _this._node.addEventListener('click', _this._openDatePicker);
        _this._node.addEventListener('focus', _this._openDatePicker);
      }
      if (!_this._option.disableCloseOnClickOutside) {
        window.document.addEventListener('click', _this._clickOutsideHandler);
      }
    };
    this._clickOutsideHandler = function (_a) {
      var target = _a.target;
      var targetElement = target;
      do {
        if (_this._node === targetElement || _this._calendarWrapper === targetElement) {
          return;
        }
        // typecasting to prevent flow type checking error
        targetElement = targetElement.parentNode;
      } while (targetElement);
      _this._closeDatePicker();
    };
    this._openDatePicker = function () {
      var _a = _this._flatPickrInstance,
        _b = _a.config,
        minDate = _b.minDate,
        maxDate = _b.maxDate,
        currentYear = _a.currentYear;
      _this._calendarWrapper.classList.add('show');
      _this._setCalendarWrapperPosition();
      if (_this._node !== document.activeElement) {
        _this._node.focus();
      }
      /**
       * Manually disable left/right dropdown arrows because they faulty
       * show next-month and prev-month instead of years
       */
      if (minDate && currentYear === minDate.getFullYear() && !_this._flatPickrInstance.prevMonthNav.classList.contains('flatpickr-disabled')) {
        _this._flatPickrInstance.prevMonthNav.classList.add('flatpickr-disabled');
      }
      if (maxDate && currentYear === maxDate.getFullYear() && !_this._flatPickrInstance.nextMonthNav.classList.contains('flatpickr-disabled')) {
        _this._flatPickrInstance.nextMonthNav.classList.add('flatpickr-disabled');
      }
    };
    this._closeDatePicker = function () {
      _this._calendarWrapper.classList.remove('show');
      _this._resetCalendarWrapperPosition();
    };
    this.toggleDatePicker = function () {
      if (_this._calendarWrapper.classList.contains('show')) {
        _this._closeDatePicker();
      } else {
        _this._openDatePicker();
      }
    };
    this.setDate = function (date) {
      var TRIGGER_ONCHANGE_FOR_PLUGINS = true;
      var _a = _this._flatPickrInstance.config,
        minDate = _a.minDate,
        maxDate = _a.maxDate;
      if (!date) {
        return;
      }
      if (minDate && checkIfSmallerMonth(date, minDate) || maxDate && checkIfSmallerMonth(maxDate, date)) {
        throw new Error('Date is outside of the min/max range');
      }
      var currentDate = _this._flatPickrInstance.selectedDates[0];
      if (!currentDate) {
        _this._flatPickrInstance.setDate(date, TRIGGER_ONCHANGE_FOR_PLUGINS);
        return;
      }
      /**
       * Manually dispatching a click event on the arrow buttons triggers
       * the month element rebuild. This ensures the correct state of the elements
       * https://personio.atlassian.net/browse/DST-2532
       */
      if (date.getFullYear() > currentDate.getFullYear()) {
        _this._flatPickrInstance.nextMonthNav.dispatchEvent(new Event('click'));
      } else if (date.getFullYear() < currentDate.getFullYear()) {
        _this._flatPickrInstance.prevMonthNav.dispatchEvent(new Event('click'));
      }
      _this._flatPickrInstance.setDate(date, TRIGGER_ONCHANGE_FOR_PLUGINS);
    };
    this.destroy = function () {
      if (!_this._option.disableToggleOnClick) {
        _this._node.removeEventListener('click', _this._openDatePicker);
        _this._node.removeEventListener('focus', _this._openDatePicker);
      }
      if (!_this._option.disableCloseOnClickOutside) {
        window.document.removeEventListener('click', _this._clickOutsideHandler);
      }
      _this._flatPickrInstance.destroy();
      _this._nodeParent.removeChild(_this._calendarWrapper);
    };
    var optionsWithDefault = __assign(__assign({}, defaultOptions), options);
    if (node) {
      var initialDate = optionsWithDefault.initialDate,
        locale = optionsWithDefault.locale,
        onChange_1 = optionsWithDefault.onChange,
        disableCloseOnSelectDate_1 = optionsWithDefault.disableCloseOnSelectDate,
        disableCloseOnClickOutside = optionsWithDefault.disableCloseOnClickOutside,
        disableToggleOnClick = optionsWithDefault.disableToggleOnClick,
        position = optionsWithDefault.position,
        restOption = __rest(optionsWithDefault, ["initialDate", "locale", "onChange", "disableCloseOnSelectDate", "disableCloseOnClickOutside", "disableToggleOnClick", "position"]);
      this._node = node;
      this._nodeParent = this._findNodeParent();
      this._calendarWrapper = this._createCalendarWrapper();
      this._nodeParent.appendChild(this._calendarWrapper);
      var onChangeModified = function (dateArray) {
        if (!disableCloseOnSelectDate_1) {
          _this._closeDatePicker();
        }
        var date = Array.isArray(dateArray) ? dateArray[0] : undefined;
        onChange_1(date);
      };
      var finalOption = __assign(__assign(__assign(__assign({}, defaultFlatPickrOption), restOption), localeDictionary[locale]), {
        onChange: onChangeModified
      });
      this._option = {
        disableToggleOnClick: disableToggleOnClick,
        disableCloseOnClickOutside: disableCloseOnClickOutside
      };
      // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore Flatpicker does not have a "void" return type
      this._flatPickrInstance = new Flatpickr__default["default"](this._calendarWrapper.firstChild, finalOption);
      if (initialDate instanceof Date) {
        this._flatPickrInstance.setDate(initialDate);
      }
      this._position = position;
      this._addEventListeners();
    }
  }
  return DatePicker;
}();
var ReactDatePickerRaw = /** @class */function (_super) {
  __extends(ReactDatePickerRaw, _super);
  function ReactDatePickerRaw(props) {
    var _this = _super.call(this, props) || this;
    _this.inputRef = React__namespace.createRef();
    _this.initialConfiguration = function () {
      var _a = _this.props,
        initialDate = _a.initialDate,
        selected = _a.selected;
      if (initialDate instanceof Date) {
        _this.setDateValueWithFormat(initialDate);
      }
      if (selected instanceof Date) {
        _this.setDateOnCalendarAndInput(selected);
      }
    };
    _this.setDateOnCalendarAndInput = function (date) {
      _this.setDateValueWithFormat(date);
      _this.datePicker.setDate(date);
    };
    _this.setDateValueWithFormat = function (date) {
      var dateFormat = _this.props.dateFormat;
      var value = _this.state.value;
      if (!date) {
        return;
      }
      var transformedDateFormat = transformDateFormat(dateFormat);
      var newValue = _this.datePicker._flatPickrInstance.formatDate(date, transformedDateFormat);
      if (newValue !== value) {
        _this.setState({
          value: newValue
        });
      }
    };
    _this.onInputChangeHandler = function (e) {
      if (e.target instanceof HTMLInputElement) {
        _this.setState({
          value: e.target.value
        }, function () {
          var value = _this.state.value;
          var _a = _this.props,
            dateFormat = _a.dateFormat,
            onDateChange = _a.onDateChange;
          var isValidDate = value.length === (dateFormat ? dateFormat.length : -1);
          var transformedDateFormat = transformDateFormat(dateFormat);
          var parsedDate = _this.datePicker._flatPickrInstance.parseDate(value, transformedDateFormat);
          var validatedDate = isValidDate ? parsedDate : undefined;
          onDateChange(validatedDate);
          _this.datePicker.setDate(validatedDate);
        });
      }
    };
    _this.onDateChangeHandler = function (date) {
      var _a = _this.props,
        onDateChange = _a.onDateChange,
        selected = _a.selected;
      if (date) {
        _this.setDateValueWithFormat(date);
        onDateChange(date);
      } else {
        _this.datePicker.setDate(selected);
      }
    };
    _this.renderDatePicker = function () {
      var _a = _this.props,
        flatpickrOptions = _a.flatpickrOptions,
        locale = _a.locale,
        initialDate = _a.initialDate,
        disableCloseOnSelectDate = _a.disableCloseOnSelectDate,
        disableCloseOnClickOutside = _a.disableCloseOnClickOutside,
        disableToggleOnClick = _a.disableToggleOnClick,
        position = _a.position;
      var options = __assign(__assign({}, flatpickrOptions), {
        locale: locale,
        initialDate: initialDate,
        disableCloseOnSelectDate: disableCloseOnSelectDate,
        disableCloseOnClickOutside: disableCloseOnClickOutside,
        disableToggleOnClick: disableToggleOnClick,
        position: position,
        onChange: _this.onDateChangeHandler
      });
      if (_this.datePicker) {
        _this.datePicker.destroy();
      }
      // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore migrate the LegacyRef so it will be type checked
      _this.datePicker = new DatePicker(_this.inputRef.current.ref, options);
    };
    _this.state = {
      value: ''
    };
    return _this;
  }
  ReactDatePickerRaw.prototype.componentDidMount = function () {
    this.renderDatePicker();
    this.initialConfiguration();
  };
  ReactDatePickerRaw.prototype.componentDidUpdate = function (_a) {
    var prevSelected = _a.selected,
      prevFlatpickrOptions = _a.flatpickrOptions;
    var _b = this.props,
      selected = _b.selected,
      flatpickrOptions = _b.flatpickrOptions;
    if (JSON.stringify(flatpickrOptions) !== JSON.stringify(prevFlatpickrOptions)) {
      this.renderDatePicker();
      this.initialConfiguration();
    } else if (selected instanceof Date && typeof prevSelected === 'undefined' || selected instanceof Date && prevSelected instanceof Date && checkIfDifferentMonth(selected, prevSelected)) {
      this.setDateOnCalendarAndInput(selected);
    } else if (!selected && prevSelected instanceof Date) {
      this.setDateOnCalendarAndInput(prevSelected);
    }
  };
  ReactDatePickerRaw.prototype.componentWillUnmount = function () {
    this.datePicker.destroy();
  };
  ReactDatePickerRaw.prototype.render = function () {
    var children = this.props.children;
    var value = this.state.value;
    return children({
      value: value,
      inputRef: this.inputRef,
      onChange: this.onInputChangeHandler
    });
  };
  // eslint-disable-next-line react/static-property-placement
  ReactDatePickerRaw.defaultProps = {
    locale: 'en-GB',
    selected: undefined,
    initialDate: undefined,
    position: undefined,
    disableCloseOnSelectDate: false,
    disableCloseOnClickOutside: false,
    disableToggleOnClick: false,
    dateFormat: 'DD.MM.YYYY',
    flatpickrOptions: {}
  };
  return ReactDatePickerRaw;
}(React__namespace.Component);
var MEDIUM = 'medium';
var SMALL = 'small';
function getIconSize(size) {
  if (size === SMALL) {
    return 14;
  }
  return 18;
}
function getSize(size) {
  var _a;
  return _a = {}, _a[styles.small] = size === SMALL, _a[styles.medium] = size === MEDIUM, _a;
}
function getFirstDayOfMonth(date) {
  var today = date || new Date();
  var calculatedDate = new Date(today.getTime() + today.getTimezoneOffset() * 60000);
  return new Date(calculatedDate.getFullYear(), calculatedDate.getMonth(), 1);
}
var MonthNavigation = function (_a) {
  var _b = _a.size,
    size = _b === void 0 ? MEDIUM : _b,
    selected = _a.selected,
    onFocus = _a.onFocus,
    onBlur = _a.onBlur,
    metadata = _a.metadata,
    _c = _a.showTodayButton,
    showTodayButton = _c === void 0 ? true : _c,
    _d = _a.todayText,
    todayText = _d === void 0 ? 'Today' : _d,
    className = _a.className,
    // datepicker props
    _e = _a.dateFormat,
    // datepicker props
    dateFormat = _e === void 0 ? 'F YYYY' : _e,
    _f = _a.flatpickrOptions,
    flatpickrOptions = _f === void 0 ? {} : _f,
    propsLocale = _a.locale,
    initialDate = _a.initialDate,
    onDateChange = _a.onDateChange,
    _g = _a.disableCloseOnSelectDate,
    disableCloseOnSelectDate = _g === void 0 ? false : _g,
    _h = _a.disableCloseOnClickOutside,
    disableCloseOnClickOutside = _h === void 0 ? false : _h,
    _j = _a.disableToggleOnClick,
    disableToggleOnClick = _j === void 0 ? false : _j,
    _k = _a.monthSelectPluginOptions,
    monthSelectPluginOptions = _k === void 0 ? {
      shorthand: true
    } : _k;
  var prevSelected = React.useRef(null);
  var appLocale = i18n.useLocale().locale;
  var locale = propsLocale || appLocale || 'en-GB';
  var _l = React.useState(getFirstDayOfMonth(initialDate)),
    date = _l[0],
    setDate = _l[1];
  var _m = React.useState(null),
    newMinDate = _m[0],
    setNewMinDate = _m[1];
  var _o = React.useState(null),
    newMaxDate = _o[0],
    setNewMaxDate = _o[1];
  var handleDateChange = React.useCallback(function (newDate) {
    if (newDate === void 0) {
      newDate = null;
    }
    if (prevSelected.current === null || newDate === null || checkIfDifferentMonth(prevSelected.current, newDate)) {
      prevSelected.current = newDate;
      setDate(newDate);
      onDateChange(newDate);
    }
  }, [setDate, onDateChange]);
  var decreaseDate = React.useCallback(function () {
    if (date) {
      var newDate = getNextMonth(date, -1);
      setDate(newDate);
      onDateChange(newDate);
    }
  }, [onDateChange, setDate, date]);
  var increaseDate = React.useCallback(function () {
    if (date) {
      var newDate = getNextMonth(date, +1);
      setDate(newDate);
      onDateChange(newDate);
    }
  }, [onDateChange, setDate, date]);
  var onTodayClick = React.useCallback(function (e) {
    var newDate = getFirstDayOfMonth();
    setDate(newDate);
    onDateChange(newDate);
    window.document.activeElement.blur();
    if (e) {
      e.preventDefault();
    }
  }, [onDateChange, setDate]);
  React.useEffect(function () {
    if (!selected || !(selected instanceof Date)) {
      return;
    }
    var newSelected = getFirstDayOfMonth(selected);
    if (!prevSelected.current || newSelected !== prevSelected.current) {
      setDate(newSelected);
    }
    prevSelected.current = newSelected;
  }, [selected]);
  React.useEffect(function () {
    var minDate = flatpickrOptions === null || flatpickrOptions === void 0 ? void 0 : flatpickrOptions.minDate;
    var maxDate = flatpickrOptions === null || flatpickrOptions === void 0 ? void 0 : flatpickrOptions.maxDate;
    setNewMinDate(minDate ? getFirstDayOfMonth(minDate instanceof Date ? minDate : new Date(minDate)) : null);
    setNewMaxDate(maxDate ? getFirstDayOfMonth(maxDate instanceof Date ? maxDate : new Date(maxDate)) : null);
  }, [flatpickrOptions === null || flatpickrOptions === void 0 ? void 0 : flatpickrOptions.minDate, flatpickrOptions === null || flatpickrOptions === void 0 ? void 0 : flatpickrOptions.maxDate]);
  return React__default["default"].createElement(ReactDatePickerRaw, {
    onDateChange: handleDateChange,
    dateFormat: dateFormat,
    selected: date,
    locale: locale,
    initialDate: initialDate ? getFirstDayOfMonth(initialDate) : undefined,
    disableCloseOnSelectDate: disableCloseOnSelectDate,
    disableCloseOnClickOutside: disableCloseOnClickOutside,
    disableToggleOnClick: disableToggleOnClick,
    flatpickrOptions: __assign(__assign({}, flatpickrOptions), {
      minDate: newMinDate || undefined,
      maxDate: newMaxDate || undefined,
      plugins: [MonthSelectPlugin__default["default"](__assign({}, monthSelectPluginOptions))]
    })
  }, function (_a) {
    var _b;
    var value = _a.value,
      inputRef = _a.inputRef,
      onChange = _a.onChange;
    return React__default["default"].createElement("div", __assign({}, utilsCommons.parseMetadata(metadata), {
      className: classnames__default["default"](styles.wrapper, getSize(size), (_b = {}, _b[styles.noTodayButton] = !showTodayButton, _b), className)
    }), React__default["default"].createElement("div", {
      className: styles.controlWrapper
    }, React__default["default"].createElement("button", {
      type: "button",
      "aria-label": "Previous Month",
      onClick: decreaseDate,
      disabled: Boolean(newMinDate && date && checkIfSmallerMonth(getNextMonth(date, -1), newMinDate)),
      className: classnames__default["default"](styles.controlButton, getSize(size)),
      "data-test-id": TEST_IDS.MONTH_PICKER_PREVIOUS_BUTTON
    }, React__default["default"].createElement(icon.Icon, {
      name: "arrow-left",
      size: getIconSize(size),
      className: styles.icon
    })), React__default["default"].createElement("button", {
      type: "button",
      "aria-label": "Next Month",
      onClick: increaseDate,
      disabled: Boolean(newMaxDate && date && checkIfSmallerMonth(newMaxDate, getNextMonth(date, 1))),
      className: classnames__default["default"](styles.controlButton, getSize(size)),
      "data-test-id": TEST_IDS.MONTH_PICKER_NEXT_BUTTON
    }, React__default["default"].createElement(icon.Icon, {
      name: "arrow-right",
      size: getIconSize(size),
      className: styles.icon
    }))), React__default["default"].createElement("div", null, React__default["default"].createElement(MonthNavigationInput
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore refactoring ReactDatePickerRaw not to use LegacyRef is needed
    , {
      // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore refactoring ReactDatePickerRaw not to use LegacyRef is needed
      ref: inputRef,
      value: value,
      type: "text",
      onChange: onChange,
      onFocus: onFocus,
      onBlur: onBlur,
      className: classnames__default["default"](styles.input, getSize(size)),
      "data-test-id": TEST_IDS.MONTH_PICKER_INPUT
    })), showTodayButton && (!date || checkIfDifferentMonth(date, new Date())) && React__default["default"].createElement(button.Button, {
      onClick: onTodayClick,
      variant: "tertiary",
      className: styles.todayButton,
      "data-test-id": TEST_IDS.MONTH_PICKER_TODAY_BUTTON
    }, todayText));
  });
};
exports.MonthNavigation = MonthNavigation;
//# sourceMappingURL=index.js.map
